# ReviewsApi

All URIs are relative to *https://reputationcrm.com/v2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getCommentsonReview**](ReviewsApi.md#getCommentsonReview) | **GET** /getCommentsonReview | Get review comments
[**getReviewsByCompanyID**](ReviewsApi.md#getReviewsByCompanyID) | **GET** /getReviewsByCompanyID | Get X last reviews less than X days old of a company
[**getReviewsByCompanyIDAndReviewSite**](ReviewsApi.md#getReviewsByCompanyIDAndReviewSite) | **GET** /getReviewsByCompanyIDAndReviewSite | Get X last reviews less than X days old of a review site of a company
[**getReviewsByCompanyIDRatingAndReviewSite**](ReviewsApi.md#getReviewsByCompanyIDRatingAndReviewSite) | **GET** /getReviewsByCompanyIDRatingAndReviewSite | Get X last reviews that equal or over X stars of a review site of a company
[**getReviewsByCompanyIdAndRating**](ReviewsApi.md#getReviewsByCompanyIdAndRating) | **GET** /getReviewsByCompanyIdAndRating | Get X last reviews that equal or over X stars of a company
[**getReviewsByUserName**](ReviewsApi.md#getReviewsByUserName) | **GET** /getReviewsByUserName | Get X last reviews less than X days old of an account
[**getReviewsByUserNameAndRating**](ReviewsApi.md#getReviewsByUserNameAndRating) | **GET** /getReviewsByUserNameAndRating | Get X last reviews that equal or over X stars of an account
[**getReviewsByUserNameAndReviewSite**](ReviewsApi.md#getReviewsByUserNameAndReviewSite) | **GET** /getReviewsByUserNameAndReviewSite | Get X last reviews less than X days old of a review site of an account
[**getReviewsByUserNameRatingAndReviewSite**](ReviewsApi.md#getReviewsByUserNameRatingAndReviewSite) | **GET** /getReviewsByUserNameRatingAndReviewSite | Get X last reviews that equal or over X stars of a review site of an account
[**postCommentOnReview**](ReviewsApi.md#postCommentOnReview) | **POST** /postCommentOnReview | Comment on a Feedback / Review


<a name="getCommentsonReview"></a>
# **getCommentsonReview**
> List&lt;Comment&gt; getCommentsonReview(companyid, reviewid)

Get review comments

Get review comments

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ReviewsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

ReviewsApi apiInstance = new ReviewsApi();
String companyid = "companyid_example"; // String | Company ID
String reviewid = "reviewid_example"; // String | Review ID
try {
    List<Comment> result = apiInstance.getCommentsonReview(companyid, reviewid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReviewsApi#getCommentsonReview");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **String**| Company ID | [optional]
 **reviewid** | **String**| Review ID | [optional]

### Return type

[**List&lt;Comment&gt;**](Comment.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="getReviewsByCompanyID"></a>
# **getReviewsByCompanyID**
> List&lt;Review&gt; getReviewsByCompanyID(companyid, howManyReviews, lastHowManyDays)

Get X last reviews less than X days old of a company

Get X last reviews less than X days old (For example, last 100 reviews that are less than 365 days old)

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ReviewsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

ReviewsApi apiInstance = new ReviewsApi();
String companyid = "companyid_example"; // String | Company ID
String howManyReviews = "howManyReviews_example"; // String | How many reviews
String lastHowManyDays = "lastHowManyDays_example"; // String | How many days back
try {
    List<Review> result = apiInstance.getReviewsByCompanyID(companyid, howManyReviews, lastHowManyDays);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReviewsApi#getReviewsByCompanyID");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **String**| Company ID |
 **howManyReviews** | **String**| How many reviews |
 **lastHowManyDays** | **String**| How many days back |

### Return type

[**List&lt;Review&gt;**](Review.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="getReviewsByCompanyIDAndReviewSite"></a>
# **getReviewsByCompanyIDAndReviewSite**
> List&lt;Review&gt; getReviewsByCompanyIDAndReviewSite(companyid, howManyReviews, lastHowManyDays, reviewsSite)

Get X last reviews less than X days old of a review site of a company

Get X last reviews less than X days old of a review site (For example, Google reviewsâ€¦)

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ReviewsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

ReviewsApi apiInstance = new ReviewsApi();
String companyid = "companyid_example"; // String | Company ID
String howManyReviews = "howManyReviews_example"; // String | How many reviews
String lastHowManyDays = "lastHowManyDays_example"; // String | How many days back
String reviewsSite = "reviewsSite_example"; // String | Review site name
try {
    List<Review> result = apiInstance.getReviewsByCompanyIDAndReviewSite(companyid, howManyReviews, lastHowManyDays, reviewsSite);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReviewsApi#getReviewsByCompanyIDAndReviewSite");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **String**| Company ID |
 **howManyReviews** | **String**| How many reviews |
 **lastHowManyDays** | **String**| How many days back |
 **reviewsSite** | **String**| Review site name |

### Return type

[**List&lt;Review&gt;**](Review.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="getReviewsByCompanyIDRatingAndReviewSite"></a>
# **getReviewsByCompanyIDRatingAndReviewSite**
> List&lt;Review&gt; getReviewsByCompanyIDRatingAndReviewSite(companyid, howManyReviews, minimumRatings, reviewsSite)

Get X last reviews that equal or over X stars of a review site of a company

Get X last reviews that equal or over X stars of a review site (For example, Google reviewsâ€¦)

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ReviewsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

ReviewsApi apiInstance = new ReviewsApi();
String companyid = "companyid_example"; // String | Company ID
String howManyReviews = "howManyReviews_example"; // String | How many reviews
String minimumRatings = "minimumRatings_example"; // String | Minimum review rating (reviews that are equal or over minimumRatings stars)
String reviewsSite = "reviewsSite_example"; // String | Review site name
try {
    List<Review> result = apiInstance.getReviewsByCompanyIDRatingAndReviewSite(companyid, howManyReviews, minimumRatings, reviewsSite);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReviewsApi#getReviewsByCompanyIDRatingAndReviewSite");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **String**| Company ID |
 **howManyReviews** | **String**| How many reviews |
 **minimumRatings** | **String**| Minimum review rating (reviews that are equal or over minimumRatings stars) |
 **reviewsSite** | **String**| Review site name |

### Return type

[**List&lt;Review&gt;**](Review.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="getReviewsByCompanyIdAndRating"></a>
# **getReviewsByCompanyIdAndRating**
> List&lt;Review&gt; getReviewsByCompanyIdAndRating(companyid, howManyReviews, lastHowManyDays, minimumRatings, maximumRatings)

Get X last reviews that equal or over X stars of a company

Get X last reviews that between X stars (For example, last 50 reviews between 2 to 5 stars)

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ReviewsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

ReviewsApi apiInstance = new ReviewsApi();
String companyid = "companyid_example"; // String | Company ID
String howManyReviews = "howManyReviews_example"; // String | How many reviews
String lastHowManyDays = "lastHowManyDays_example"; // String | How many days back
String minimumRatings = "minimumRatings_example"; // String | Minimum review rating (reviews that are equal or over minimumRatings stars)
String maximumRatings = "maximumRatings_example"; // String | Maximum review rating
try {
    List<Review> result = apiInstance.getReviewsByCompanyIdAndRating(companyid, howManyReviews, lastHowManyDays, minimumRatings, maximumRatings);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReviewsApi#getReviewsByCompanyIdAndRating");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **companyid** | **String**| Company ID |
 **howManyReviews** | **String**| How many reviews |
 **lastHowManyDays** | **String**| How many days back |
 **minimumRatings** | **String**| Minimum review rating (reviews that are equal or over minimumRatings stars) |
 **maximumRatings** | **String**| Maximum review rating |

### Return type

[**List&lt;Review&gt;**](Review.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="getReviewsByUserName"></a>
# **getReviewsByUserName**
> List&lt;Review&gt; getReviewsByUserName(username, howManyReviews, lastHowManyDays)

Get X last reviews less than X days old of an account

Get X last reviews less than X days old (For example, last 100 reviews that are less than 365 days old)

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ReviewsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

ReviewsApi apiInstance = new ReviewsApi();
String username = "username_example"; // String | User Name or Email address
String howManyReviews = "howManyReviews_example"; // String | How many reviews
String lastHowManyDays = "lastHowManyDays_example"; // String | How many days back
try {
    List<Review> result = apiInstance.getReviewsByUserName(username, howManyReviews, lastHowManyDays);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReviewsApi#getReviewsByUserName");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**| User Name or Email address |
 **howManyReviews** | **String**| How many reviews |
 **lastHowManyDays** | **String**| How many days back |

### Return type

[**List&lt;Review&gt;**](Review.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="getReviewsByUserNameAndRating"></a>
# **getReviewsByUserNameAndRating**
> List&lt;Review&gt; getReviewsByUserNameAndRating(username, howManyReviews, lastHowManyDays, minimumRatings)

Get X last reviews that equal or over X stars of an account

Get X last reviews that equal or over X stars (For example, last 50 reviews that are equal or over 4 stars)

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ReviewsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

ReviewsApi apiInstance = new ReviewsApi();
String username = "username_example"; // String | User Name or Email address
String howManyReviews = "howManyReviews_example"; // String | How many reviews
String lastHowManyDays = "lastHowManyDays_example"; // String | How many days back
String minimumRatings = "minimumRatings_example"; // String | Minimum review rating (reviews that are equal or over minimumRatings stars)
try {
    List<Review> result = apiInstance.getReviewsByUserNameAndRating(username, howManyReviews, lastHowManyDays, minimumRatings);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReviewsApi#getReviewsByUserNameAndRating");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**| User Name or Email address |
 **howManyReviews** | **String**| How many reviews |
 **lastHowManyDays** | **String**| How many days back |
 **minimumRatings** | **String**| Minimum review rating (reviews that are equal or over minimumRatings stars) |

### Return type

[**List&lt;Review&gt;**](Review.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="getReviewsByUserNameAndReviewSite"></a>
# **getReviewsByUserNameAndReviewSite**
> List&lt;Review&gt; getReviewsByUserNameAndReviewSite(username, howManyReviews, lastHowManyDays, reviewsSite)

Get X last reviews less than X days old of a review site of an account

Get X last reviews less than X days old of a review site (For Example, Google reviewsâ€¦)

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ReviewsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

ReviewsApi apiInstance = new ReviewsApi();
String username = "username_example"; // String | User Name or Email address
String howManyReviews = "howManyReviews_example"; // String | How many reviews
String lastHowManyDays = "lastHowManyDays_example"; // String | How many days back
String reviewsSite = "reviewsSite_example"; // String | Review site name
try {
    List<Review> result = apiInstance.getReviewsByUserNameAndReviewSite(username, howManyReviews, lastHowManyDays, reviewsSite);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReviewsApi#getReviewsByUserNameAndReviewSite");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**| User Name or Email address |
 **howManyReviews** | **String**| How many reviews |
 **lastHowManyDays** | **String**| How many days back |
 **reviewsSite** | **String**| Review site name |

### Return type

[**List&lt;Review&gt;**](Review.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="getReviewsByUserNameRatingAndReviewSite"></a>
# **getReviewsByUserNameRatingAndReviewSite**
> List&lt;Review&gt; getReviewsByUserNameRatingAndReviewSite(username, howManyReviews, minimumRatings, reviewsSite)

Get X last reviews that equal or over X stars of a review site of an account

Get X last reviews that equal or over X stars of a review site (For example, Google reviewsâ€¦)

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ReviewsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

ReviewsApi apiInstance = new ReviewsApi();
String username = "username_example"; // String | User Name or Email address
String howManyReviews = "howManyReviews_example"; // String | How many reviews
String minimumRatings = "minimumRatings_example"; // String | Minimum review rating (reviews that are equal or over minimumRatings stars)
String reviewsSite = "reviewsSite_example"; // String | Review site name
try {
    List<Review> result = apiInstance.getReviewsByUserNameRatingAndReviewSite(username, howManyReviews, minimumRatings, reviewsSite);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReviewsApi#getReviewsByUserNameRatingAndReviewSite");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**| User Name or Email address |
 **howManyReviews** | **String**| How many reviews |
 **minimumRatings** | **String**| Minimum review rating (reviews that are equal or over minimumRatings stars) |
 **reviewsSite** | **String**| Review site name |

### Return type

[**List&lt;Review&gt;**](Review.md)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

<a name="postCommentOnReview"></a>
# **postCommentOnReview**
> postCommentOnReview(reviewid, commenttext)

Comment on a Feedback / Review

This API call posts a Comment on a Feedback / Review. When posted, the Platform sends an Email to the Commenter / Reviewer with a copy of the posted Comment. NOTE: The Moderation Team receives a copy of the Email sent to the Commenter / Reviewer  The API call has the same effect as using the Reputation Control Center (URL: https://reputationcrm.com/reputation-control), locating in the datatable the Feedback / Review that will be commented, and clicking on the &#39;Comment on the Platform&#39; button to leave a Comment  Please refer https://reputationcrm.com/api/repcrm-api-img/CommentOnReview.jpg for more information 

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ReviewsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: api_key
ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
api_key.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//api_key.setApiKeyPrefix("Token");

ReviewsApi apiInstance = new ReviewsApi();
String reviewid = "reviewid_example"; // String | Review ID
String commenttext = "commenttext_example"; // String | Comment Text 
try {
    apiInstance.postCommentOnReview(reviewid, commenttext);
} catch (ApiException e) {
    System.err.println("Exception when calling ReviewsApi#postCommentOnReview");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **reviewid** | **String**| Review ID |
 **commenttext** | **String**| Comment Text  |

### Return type

null (empty response body)

### Authorization

[api_key](../README.md#api_key)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json, application/xml

