/*
 * Reputation CRM API
 * Move your app forward with the Reputation CRM API  To get your `API key`, visit [Reputation CRM](https://reputationcrm.com/settings/index/Reputation-Builder)  Your API Key can be found in Settings -> Reputation Builder -> Reputation Builder -> API Tab   [Download API SDK](https://reputationcrm.com/developers/documentation/v2/downloads)  [API Explorer](https://reputationcrm.com/developers/documentation/v2/explorer/) 
 *
 * OpenAPI spec version: 2.0.2
 * Contact: support@reputationcrm.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.Comment;
import io.swagger.client.model.Error;
import io.swagger.client.model.Review;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ReviewsApi {
    private ApiClient apiClient;

    public ReviewsApi() {
        this(Configuration.getDefaultApiClient());
    }

    public ReviewsApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for getCommentsonReview
     * @param companyid Company ID (optional)
     * @param reviewid Review ID (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getCommentsonReviewCall(String companyid, String reviewid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/getCommentsonReview";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (companyid != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("companyid", companyid));
        if (reviewid != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("reviewid", reviewid));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getCommentsonReviewValidateBeforeCall(String companyid, String reviewid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        

        com.squareup.okhttp.Call call = getCommentsonReviewCall(companyid, reviewid, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get review comments
     * Get review comments
     * @param companyid Company ID (optional)
     * @param reviewid Review ID (optional)
     * @return List&lt;Comment&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Comment> getCommentsonReview(String companyid, String reviewid) throws ApiException {
        ApiResponse<List<Comment>> resp = getCommentsonReviewWithHttpInfo(companyid, reviewid);
        return resp.getData();
    }

    /**
     * Get review comments
     * Get review comments
     * @param companyid Company ID (optional)
     * @param reviewid Review ID (optional)
     * @return ApiResponse&lt;List&lt;Comment&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Comment>> getCommentsonReviewWithHttpInfo(String companyid, String reviewid) throws ApiException {
        com.squareup.okhttp.Call call = getCommentsonReviewValidateBeforeCall(companyid, reviewid, null, null);
        Type localVarReturnType = new TypeToken<List<Comment>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get review comments (asynchronously)
     * Get review comments
     * @param companyid Company ID (optional)
     * @param reviewid Review ID (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getCommentsonReviewAsync(String companyid, String reviewid, final ApiCallback<List<Comment>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getCommentsonReviewValidateBeforeCall(companyid, reviewid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Comment>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getReviewsByCompanyID
     * @param companyid Company ID (required)
     * @param howManyReviews How many reviews (required)
     * @param lastHowManyDays How many days back (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getReviewsByCompanyIDCall(String companyid, String howManyReviews, String lastHowManyDays, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/getReviewsByCompanyID";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (companyid != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("companyid", companyid));
        if (howManyReviews != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("howManyReviews", howManyReviews));
        if (lastHowManyDays != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("lastHowManyDays", lastHowManyDays));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getReviewsByCompanyIDValidateBeforeCall(String companyid, String howManyReviews, String lastHowManyDays, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'companyid' is set
        if (companyid == null) {
            throw new ApiException("Missing the required parameter 'companyid' when calling getReviewsByCompanyID(Async)");
        }
        
        // verify the required parameter 'howManyReviews' is set
        if (howManyReviews == null) {
            throw new ApiException("Missing the required parameter 'howManyReviews' when calling getReviewsByCompanyID(Async)");
        }
        
        // verify the required parameter 'lastHowManyDays' is set
        if (lastHowManyDays == null) {
            throw new ApiException("Missing the required parameter 'lastHowManyDays' when calling getReviewsByCompanyID(Async)");
        }
        

        com.squareup.okhttp.Call call = getReviewsByCompanyIDCall(companyid, howManyReviews, lastHowManyDays, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get X last reviews less than X days old of a company
     * Get X last reviews less than X days old (For example, last 100 reviews that are less than 365 days old)
     * @param companyid Company ID (required)
     * @param howManyReviews How many reviews (required)
     * @param lastHowManyDays How many days back (required)
     * @return List&lt;Review&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Review> getReviewsByCompanyID(String companyid, String howManyReviews, String lastHowManyDays) throws ApiException {
        ApiResponse<List<Review>> resp = getReviewsByCompanyIDWithHttpInfo(companyid, howManyReviews, lastHowManyDays);
        return resp.getData();
    }

    /**
     * Get X last reviews less than X days old of a company
     * Get X last reviews less than X days old (For example, last 100 reviews that are less than 365 days old)
     * @param companyid Company ID (required)
     * @param howManyReviews How many reviews (required)
     * @param lastHowManyDays How many days back (required)
     * @return ApiResponse&lt;List&lt;Review&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Review>> getReviewsByCompanyIDWithHttpInfo(String companyid, String howManyReviews, String lastHowManyDays) throws ApiException {
        com.squareup.okhttp.Call call = getReviewsByCompanyIDValidateBeforeCall(companyid, howManyReviews, lastHowManyDays, null, null);
        Type localVarReturnType = new TypeToken<List<Review>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get X last reviews less than X days old of a company (asynchronously)
     * Get X last reviews less than X days old (For example, last 100 reviews that are less than 365 days old)
     * @param companyid Company ID (required)
     * @param howManyReviews How many reviews (required)
     * @param lastHowManyDays How many days back (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getReviewsByCompanyIDAsync(String companyid, String howManyReviews, String lastHowManyDays, final ApiCallback<List<Review>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getReviewsByCompanyIDValidateBeforeCall(companyid, howManyReviews, lastHowManyDays, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Review>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getReviewsByCompanyIDAndReviewSite
     * @param companyid Company ID (required)
     * @param howManyReviews How many reviews (required)
     * @param lastHowManyDays How many days back (required)
     * @param reviewsSite Review site name (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getReviewsByCompanyIDAndReviewSiteCall(String companyid, String howManyReviews, String lastHowManyDays, String reviewsSite, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/getReviewsByCompanyIDAndReviewSite";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (companyid != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("companyid", companyid));
        if (howManyReviews != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("howManyReviews", howManyReviews));
        if (lastHowManyDays != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("lastHowManyDays", lastHowManyDays));
        if (reviewsSite != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("reviewsSite", reviewsSite));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getReviewsByCompanyIDAndReviewSiteValidateBeforeCall(String companyid, String howManyReviews, String lastHowManyDays, String reviewsSite, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'companyid' is set
        if (companyid == null) {
            throw new ApiException("Missing the required parameter 'companyid' when calling getReviewsByCompanyIDAndReviewSite(Async)");
        }
        
        // verify the required parameter 'howManyReviews' is set
        if (howManyReviews == null) {
            throw new ApiException("Missing the required parameter 'howManyReviews' when calling getReviewsByCompanyIDAndReviewSite(Async)");
        }
        
        // verify the required parameter 'lastHowManyDays' is set
        if (lastHowManyDays == null) {
            throw new ApiException("Missing the required parameter 'lastHowManyDays' when calling getReviewsByCompanyIDAndReviewSite(Async)");
        }
        
        // verify the required parameter 'reviewsSite' is set
        if (reviewsSite == null) {
            throw new ApiException("Missing the required parameter 'reviewsSite' when calling getReviewsByCompanyIDAndReviewSite(Async)");
        }
        

        com.squareup.okhttp.Call call = getReviewsByCompanyIDAndReviewSiteCall(companyid, howManyReviews, lastHowManyDays, reviewsSite, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get X last reviews less than X days old of a review site of a company
     * Get X last reviews less than X days old of a review site (For example, Google reviewsâ€¦)
     * @param companyid Company ID (required)
     * @param howManyReviews How many reviews (required)
     * @param lastHowManyDays How many days back (required)
     * @param reviewsSite Review site name (required)
     * @return List&lt;Review&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Review> getReviewsByCompanyIDAndReviewSite(String companyid, String howManyReviews, String lastHowManyDays, String reviewsSite) throws ApiException {
        ApiResponse<List<Review>> resp = getReviewsByCompanyIDAndReviewSiteWithHttpInfo(companyid, howManyReviews, lastHowManyDays, reviewsSite);
        return resp.getData();
    }

    /**
     * Get X last reviews less than X days old of a review site of a company
     * Get X last reviews less than X days old of a review site (For example, Google reviewsâ€¦)
     * @param companyid Company ID (required)
     * @param howManyReviews How many reviews (required)
     * @param lastHowManyDays How many days back (required)
     * @param reviewsSite Review site name (required)
     * @return ApiResponse&lt;List&lt;Review&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Review>> getReviewsByCompanyIDAndReviewSiteWithHttpInfo(String companyid, String howManyReviews, String lastHowManyDays, String reviewsSite) throws ApiException {
        com.squareup.okhttp.Call call = getReviewsByCompanyIDAndReviewSiteValidateBeforeCall(companyid, howManyReviews, lastHowManyDays, reviewsSite, null, null);
        Type localVarReturnType = new TypeToken<List<Review>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get X last reviews less than X days old of a review site of a company (asynchronously)
     * Get X last reviews less than X days old of a review site (For example, Google reviewsâ€¦)
     * @param companyid Company ID (required)
     * @param howManyReviews How many reviews (required)
     * @param lastHowManyDays How many days back (required)
     * @param reviewsSite Review site name (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getReviewsByCompanyIDAndReviewSiteAsync(String companyid, String howManyReviews, String lastHowManyDays, String reviewsSite, final ApiCallback<List<Review>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getReviewsByCompanyIDAndReviewSiteValidateBeforeCall(companyid, howManyReviews, lastHowManyDays, reviewsSite, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Review>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getReviewsByCompanyIDRatingAndReviewSite
     * @param companyid Company ID (required)
     * @param howManyReviews How many reviews (required)
     * @param minimumRatings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param reviewsSite Review site name (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getReviewsByCompanyIDRatingAndReviewSiteCall(String companyid, String howManyReviews, String minimumRatings, String reviewsSite, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/getReviewsByCompanyIDRatingAndReviewSite";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (companyid != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("companyid", companyid));
        if (howManyReviews != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("howManyReviews", howManyReviews));
        if (minimumRatings != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("minimumRatings", minimumRatings));
        if (reviewsSite != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("reviewsSite", reviewsSite));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getReviewsByCompanyIDRatingAndReviewSiteValidateBeforeCall(String companyid, String howManyReviews, String minimumRatings, String reviewsSite, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'companyid' is set
        if (companyid == null) {
            throw new ApiException("Missing the required parameter 'companyid' when calling getReviewsByCompanyIDRatingAndReviewSite(Async)");
        }
        
        // verify the required parameter 'howManyReviews' is set
        if (howManyReviews == null) {
            throw new ApiException("Missing the required parameter 'howManyReviews' when calling getReviewsByCompanyIDRatingAndReviewSite(Async)");
        }
        
        // verify the required parameter 'minimumRatings' is set
        if (minimumRatings == null) {
            throw new ApiException("Missing the required parameter 'minimumRatings' when calling getReviewsByCompanyIDRatingAndReviewSite(Async)");
        }
        
        // verify the required parameter 'reviewsSite' is set
        if (reviewsSite == null) {
            throw new ApiException("Missing the required parameter 'reviewsSite' when calling getReviewsByCompanyIDRatingAndReviewSite(Async)");
        }
        

        com.squareup.okhttp.Call call = getReviewsByCompanyIDRatingAndReviewSiteCall(companyid, howManyReviews, minimumRatings, reviewsSite, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get X last reviews that equal or over X stars of a review site of a company
     * Get X last reviews that equal or over X stars of a review site (For example, Google reviewsâ€¦)
     * @param companyid Company ID (required)
     * @param howManyReviews How many reviews (required)
     * @param minimumRatings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param reviewsSite Review site name (required)
     * @return List&lt;Review&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Review> getReviewsByCompanyIDRatingAndReviewSite(String companyid, String howManyReviews, String minimumRatings, String reviewsSite) throws ApiException {
        ApiResponse<List<Review>> resp = getReviewsByCompanyIDRatingAndReviewSiteWithHttpInfo(companyid, howManyReviews, minimumRatings, reviewsSite);
        return resp.getData();
    }

    /**
     * Get X last reviews that equal or over X stars of a review site of a company
     * Get X last reviews that equal or over X stars of a review site (For example, Google reviewsâ€¦)
     * @param companyid Company ID (required)
     * @param howManyReviews How many reviews (required)
     * @param minimumRatings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param reviewsSite Review site name (required)
     * @return ApiResponse&lt;List&lt;Review&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Review>> getReviewsByCompanyIDRatingAndReviewSiteWithHttpInfo(String companyid, String howManyReviews, String minimumRatings, String reviewsSite) throws ApiException {
        com.squareup.okhttp.Call call = getReviewsByCompanyIDRatingAndReviewSiteValidateBeforeCall(companyid, howManyReviews, minimumRatings, reviewsSite, null, null);
        Type localVarReturnType = new TypeToken<List<Review>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get X last reviews that equal or over X stars of a review site of a company (asynchronously)
     * Get X last reviews that equal or over X stars of a review site (For example, Google reviewsâ€¦)
     * @param companyid Company ID (required)
     * @param howManyReviews How many reviews (required)
     * @param minimumRatings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param reviewsSite Review site name (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getReviewsByCompanyIDRatingAndReviewSiteAsync(String companyid, String howManyReviews, String minimumRatings, String reviewsSite, final ApiCallback<List<Review>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getReviewsByCompanyIDRatingAndReviewSiteValidateBeforeCall(companyid, howManyReviews, minimumRatings, reviewsSite, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Review>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getReviewsByCompanyIdAndRating
     * @param companyid Company ID (required)
     * @param howManyReviews How many reviews (required)
     * @param lastHowManyDays How many days back (required)
     * @param minimumRatings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param maximumRatings Maximum review rating (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getReviewsByCompanyIdAndRatingCall(String companyid, String howManyReviews, String lastHowManyDays, String minimumRatings, String maximumRatings, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/getReviewsByCompanyIdAndRating";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (companyid != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("companyid", companyid));
        if (howManyReviews != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("howManyReviews", howManyReviews));
        if (lastHowManyDays != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("lastHowManyDays", lastHowManyDays));
        if (minimumRatings != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("minimumRatings", minimumRatings));
        if (maximumRatings != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("maximumRatings", maximumRatings));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getReviewsByCompanyIdAndRatingValidateBeforeCall(String companyid, String howManyReviews, String lastHowManyDays, String minimumRatings, String maximumRatings, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'companyid' is set
        if (companyid == null) {
            throw new ApiException("Missing the required parameter 'companyid' when calling getReviewsByCompanyIdAndRating(Async)");
        }
        
        // verify the required parameter 'howManyReviews' is set
        if (howManyReviews == null) {
            throw new ApiException("Missing the required parameter 'howManyReviews' when calling getReviewsByCompanyIdAndRating(Async)");
        }
        
        // verify the required parameter 'lastHowManyDays' is set
        if (lastHowManyDays == null) {
            throw new ApiException("Missing the required parameter 'lastHowManyDays' when calling getReviewsByCompanyIdAndRating(Async)");
        }
        
        // verify the required parameter 'minimumRatings' is set
        if (minimumRatings == null) {
            throw new ApiException("Missing the required parameter 'minimumRatings' when calling getReviewsByCompanyIdAndRating(Async)");
        }
        
        // verify the required parameter 'maximumRatings' is set
        if (maximumRatings == null) {
            throw new ApiException("Missing the required parameter 'maximumRatings' when calling getReviewsByCompanyIdAndRating(Async)");
        }
        

        com.squareup.okhttp.Call call = getReviewsByCompanyIdAndRatingCall(companyid, howManyReviews, lastHowManyDays, minimumRatings, maximumRatings, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get X last reviews that equal or over X stars of a company
     * Get X last reviews that between X stars (For example, last 50 reviews between 2 to 5 stars)
     * @param companyid Company ID (required)
     * @param howManyReviews How many reviews (required)
     * @param lastHowManyDays How many days back (required)
     * @param minimumRatings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param maximumRatings Maximum review rating (required)
     * @return List&lt;Review&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Review> getReviewsByCompanyIdAndRating(String companyid, String howManyReviews, String lastHowManyDays, String minimumRatings, String maximumRatings) throws ApiException {
        ApiResponse<List<Review>> resp = getReviewsByCompanyIdAndRatingWithHttpInfo(companyid, howManyReviews, lastHowManyDays, minimumRatings, maximumRatings);
        return resp.getData();
    }

    /**
     * Get X last reviews that equal or over X stars of a company
     * Get X last reviews that between X stars (For example, last 50 reviews between 2 to 5 stars)
     * @param companyid Company ID (required)
     * @param howManyReviews How many reviews (required)
     * @param lastHowManyDays How many days back (required)
     * @param minimumRatings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param maximumRatings Maximum review rating (required)
     * @return ApiResponse&lt;List&lt;Review&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Review>> getReviewsByCompanyIdAndRatingWithHttpInfo(String companyid, String howManyReviews, String lastHowManyDays, String minimumRatings, String maximumRatings) throws ApiException {
        com.squareup.okhttp.Call call = getReviewsByCompanyIdAndRatingValidateBeforeCall(companyid, howManyReviews, lastHowManyDays, minimumRatings, maximumRatings, null, null);
        Type localVarReturnType = new TypeToken<List<Review>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get X last reviews that equal or over X stars of a company (asynchronously)
     * Get X last reviews that between X stars (For example, last 50 reviews between 2 to 5 stars)
     * @param companyid Company ID (required)
     * @param howManyReviews How many reviews (required)
     * @param lastHowManyDays How many days back (required)
     * @param minimumRatings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param maximumRatings Maximum review rating (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getReviewsByCompanyIdAndRatingAsync(String companyid, String howManyReviews, String lastHowManyDays, String minimumRatings, String maximumRatings, final ApiCallback<List<Review>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getReviewsByCompanyIdAndRatingValidateBeforeCall(companyid, howManyReviews, lastHowManyDays, minimumRatings, maximumRatings, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Review>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getReviewsByUserName
     * @param username User Name or Email address (required)
     * @param howManyReviews How many reviews (required)
     * @param lastHowManyDays How many days back (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getReviewsByUserNameCall(String username, String howManyReviews, String lastHowManyDays, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/getReviewsByUserName";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (username != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("username", username));
        if (howManyReviews != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("howManyReviews", howManyReviews));
        if (lastHowManyDays != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("lastHowManyDays", lastHowManyDays));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getReviewsByUserNameValidateBeforeCall(String username, String howManyReviews, String lastHowManyDays, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'username' is set
        if (username == null) {
            throw new ApiException("Missing the required parameter 'username' when calling getReviewsByUserName(Async)");
        }
        
        // verify the required parameter 'howManyReviews' is set
        if (howManyReviews == null) {
            throw new ApiException("Missing the required parameter 'howManyReviews' when calling getReviewsByUserName(Async)");
        }
        
        // verify the required parameter 'lastHowManyDays' is set
        if (lastHowManyDays == null) {
            throw new ApiException("Missing the required parameter 'lastHowManyDays' when calling getReviewsByUserName(Async)");
        }
        

        com.squareup.okhttp.Call call = getReviewsByUserNameCall(username, howManyReviews, lastHowManyDays, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get X last reviews less than X days old of an account
     * Get X last reviews less than X days old (For example, last 100 reviews that are less than 365 days old)
     * @param username User Name or Email address (required)
     * @param howManyReviews How many reviews (required)
     * @param lastHowManyDays How many days back (required)
     * @return List&lt;Review&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Review> getReviewsByUserName(String username, String howManyReviews, String lastHowManyDays) throws ApiException {
        ApiResponse<List<Review>> resp = getReviewsByUserNameWithHttpInfo(username, howManyReviews, lastHowManyDays);
        return resp.getData();
    }

    /**
     * Get X last reviews less than X days old of an account
     * Get X last reviews less than X days old (For example, last 100 reviews that are less than 365 days old)
     * @param username User Name or Email address (required)
     * @param howManyReviews How many reviews (required)
     * @param lastHowManyDays How many days back (required)
     * @return ApiResponse&lt;List&lt;Review&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Review>> getReviewsByUserNameWithHttpInfo(String username, String howManyReviews, String lastHowManyDays) throws ApiException {
        com.squareup.okhttp.Call call = getReviewsByUserNameValidateBeforeCall(username, howManyReviews, lastHowManyDays, null, null);
        Type localVarReturnType = new TypeToken<List<Review>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get X last reviews less than X days old of an account (asynchronously)
     * Get X last reviews less than X days old (For example, last 100 reviews that are less than 365 days old)
     * @param username User Name or Email address (required)
     * @param howManyReviews How many reviews (required)
     * @param lastHowManyDays How many days back (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getReviewsByUserNameAsync(String username, String howManyReviews, String lastHowManyDays, final ApiCallback<List<Review>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getReviewsByUserNameValidateBeforeCall(username, howManyReviews, lastHowManyDays, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Review>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getReviewsByUserNameAndRating
     * @param username User Name or Email address (required)
     * @param howManyReviews How many reviews (required)
     * @param lastHowManyDays How many days back (required)
     * @param minimumRatings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getReviewsByUserNameAndRatingCall(String username, String howManyReviews, String lastHowManyDays, String minimumRatings, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/getReviewsByUserNameAndRating";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (username != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("username", username));
        if (howManyReviews != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("howManyReviews", howManyReviews));
        if (lastHowManyDays != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("lastHowManyDays", lastHowManyDays));
        if (minimumRatings != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("minimumRatings", minimumRatings));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getReviewsByUserNameAndRatingValidateBeforeCall(String username, String howManyReviews, String lastHowManyDays, String minimumRatings, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'username' is set
        if (username == null) {
            throw new ApiException("Missing the required parameter 'username' when calling getReviewsByUserNameAndRating(Async)");
        }
        
        // verify the required parameter 'howManyReviews' is set
        if (howManyReviews == null) {
            throw new ApiException("Missing the required parameter 'howManyReviews' when calling getReviewsByUserNameAndRating(Async)");
        }
        
        // verify the required parameter 'lastHowManyDays' is set
        if (lastHowManyDays == null) {
            throw new ApiException("Missing the required parameter 'lastHowManyDays' when calling getReviewsByUserNameAndRating(Async)");
        }
        
        // verify the required parameter 'minimumRatings' is set
        if (minimumRatings == null) {
            throw new ApiException("Missing the required parameter 'minimumRatings' when calling getReviewsByUserNameAndRating(Async)");
        }
        

        com.squareup.okhttp.Call call = getReviewsByUserNameAndRatingCall(username, howManyReviews, lastHowManyDays, minimumRatings, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get X last reviews that equal or over X stars of an account
     * Get X last reviews that equal or over X stars (For example, last 50 reviews that are equal or over 4 stars)
     * @param username User Name or Email address (required)
     * @param howManyReviews How many reviews (required)
     * @param lastHowManyDays How many days back (required)
     * @param minimumRatings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @return List&lt;Review&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Review> getReviewsByUserNameAndRating(String username, String howManyReviews, String lastHowManyDays, String minimumRatings) throws ApiException {
        ApiResponse<List<Review>> resp = getReviewsByUserNameAndRatingWithHttpInfo(username, howManyReviews, lastHowManyDays, minimumRatings);
        return resp.getData();
    }

    /**
     * Get X last reviews that equal or over X stars of an account
     * Get X last reviews that equal or over X stars (For example, last 50 reviews that are equal or over 4 stars)
     * @param username User Name or Email address (required)
     * @param howManyReviews How many reviews (required)
     * @param lastHowManyDays How many days back (required)
     * @param minimumRatings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @return ApiResponse&lt;List&lt;Review&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Review>> getReviewsByUserNameAndRatingWithHttpInfo(String username, String howManyReviews, String lastHowManyDays, String minimumRatings) throws ApiException {
        com.squareup.okhttp.Call call = getReviewsByUserNameAndRatingValidateBeforeCall(username, howManyReviews, lastHowManyDays, minimumRatings, null, null);
        Type localVarReturnType = new TypeToken<List<Review>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get X last reviews that equal or over X stars of an account (asynchronously)
     * Get X last reviews that equal or over X stars (For example, last 50 reviews that are equal or over 4 stars)
     * @param username User Name or Email address (required)
     * @param howManyReviews How many reviews (required)
     * @param lastHowManyDays How many days back (required)
     * @param minimumRatings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getReviewsByUserNameAndRatingAsync(String username, String howManyReviews, String lastHowManyDays, String minimumRatings, final ApiCallback<List<Review>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getReviewsByUserNameAndRatingValidateBeforeCall(username, howManyReviews, lastHowManyDays, minimumRatings, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Review>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getReviewsByUserNameAndReviewSite
     * @param username User Name or Email address (required)
     * @param howManyReviews How many reviews (required)
     * @param lastHowManyDays How many days back (required)
     * @param reviewsSite Review site name (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getReviewsByUserNameAndReviewSiteCall(String username, String howManyReviews, String lastHowManyDays, String reviewsSite, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/getReviewsByUserNameAndReviewSite";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (username != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("username", username));
        if (howManyReviews != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("howManyReviews", howManyReviews));
        if (lastHowManyDays != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("lastHowManyDays", lastHowManyDays));
        if (reviewsSite != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("reviewsSite", reviewsSite));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getReviewsByUserNameAndReviewSiteValidateBeforeCall(String username, String howManyReviews, String lastHowManyDays, String reviewsSite, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'username' is set
        if (username == null) {
            throw new ApiException("Missing the required parameter 'username' when calling getReviewsByUserNameAndReviewSite(Async)");
        }
        
        // verify the required parameter 'howManyReviews' is set
        if (howManyReviews == null) {
            throw new ApiException("Missing the required parameter 'howManyReviews' when calling getReviewsByUserNameAndReviewSite(Async)");
        }
        
        // verify the required parameter 'lastHowManyDays' is set
        if (lastHowManyDays == null) {
            throw new ApiException("Missing the required parameter 'lastHowManyDays' when calling getReviewsByUserNameAndReviewSite(Async)");
        }
        
        // verify the required parameter 'reviewsSite' is set
        if (reviewsSite == null) {
            throw new ApiException("Missing the required parameter 'reviewsSite' when calling getReviewsByUserNameAndReviewSite(Async)");
        }
        

        com.squareup.okhttp.Call call = getReviewsByUserNameAndReviewSiteCall(username, howManyReviews, lastHowManyDays, reviewsSite, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get X last reviews less than X days old of a review site of an account
     * Get X last reviews less than X days old of a review site (For Example, Google reviewsâ€¦)
     * @param username User Name or Email address (required)
     * @param howManyReviews How many reviews (required)
     * @param lastHowManyDays How many days back (required)
     * @param reviewsSite Review site name (required)
     * @return List&lt;Review&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Review> getReviewsByUserNameAndReviewSite(String username, String howManyReviews, String lastHowManyDays, String reviewsSite) throws ApiException {
        ApiResponse<List<Review>> resp = getReviewsByUserNameAndReviewSiteWithHttpInfo(username, howManyReviews, lastHowManyDays, reviewsSite);
        return resp.getData();
    }

    /**
     * Get X last reviews less than X days old of a review site of an account
     * Get X last reviews less than X days old of a review site (For Example, Google reviewsâ€¦)
     * @param username User Name or Email address (required)
     * @param howManyReviews How many reviews (required)
     * @param lastHowManyDays How many days back (required)
     * @param reviewsSite Review site name (required)
     * @return ApiResponse&lt;List&lt;Review&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Review>> getReviewsByUserNameAndReviewSiteWithHttpInfo(String username, String howManyReviews, String lastHowManyDays, String reviewsSite) throws ApiException {
        com.squareup.okhttp.Call call = getReviewsByUserNameAndReviewSiteValidateBeforeCall(username, howManyReviews, lastHowManyDays, reviewsSite, null, null);
        Type localVarReturnType = new TypeToken<List<Review>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get X last reviews less than X days old of a review site of an account (asynchronously)
     * Get X last reviews less than X days old of a review site (For Example, Google reviewsâ€¦)
     * @param username User Name or Email address (required)
     * @param howManyReviews How many reviews (required)
     * @param lastHowManyDays How many days back (required)
     * @param reviewsSite Review site name (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getReviewsByUserNameAndReviewSiteAsync(String username, String howManyReviews, String lastHowManyDays, String reviewsSite, final ApiCallback<List<Review>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getReviewsByUserNameAndReviewSiteValidateBeforeCall(username, howManyReviews, lastHowManyDays, reviewsSite, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Review>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getReviewsByUserNameRatingAndReviewSite
     * @param username User Name or Email address (required)
     * @param howManyReviews How many reviews (required)
     * @param minimumRatings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param reviewsSite Review site name (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getReviewsByUserNameRatingAndReviewSiteCall(String username, String howManyReviews, String minimumRatings, String reviewsSite, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/getReviewsByUserNameRatingAndReviewSite";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (username != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("username", username));
        if (howManyReviews != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("howManyReviews", howManyReviews));
        if (minimumRatings != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("minimumRatings", minimumRatings));
        if (reviewsSite != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("reviewsSite", reviewsSite));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getReviewsByUserNameRatingAndReviewSiteValidateBeforeCall(String username, String howManyReviews, String minimumRatings, String reviewsSite, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'username' is set
        if (username == null) {
            throw new ApiException("Missing the required parameter 'username' when calling getReviewsByUserNameRatingAndReviewSite(Async)");
        }
        
        // verify the required parameter 'howManyReviews' is set
        if (howManyReviews == null) {
            throw new ApiException("Missing the required parameter 'howManyReviews' when calling getReviewsByUserNameRatingAndReviewSite(Async)");
        }
        
        // verify the required parameter 'minimumRatings' is set
        if (minimumRatings == null) {
            throw new ApiException("Missing the required parameter 'minimumRatings' when calling getReviewsByUserNameRatingAndReviewSite(Async)");
        }
        
        // verify the required parameter 'reviewsSite' is set
        if (reviewsSite == null) {
            throw new ApiException("Missing the required parameter 'reviewsSite' when calling getReviewsByUserNameRatingAndReviewSite(Async)");
        }
        

        com.squareup.okhttp.Call call = getReviewsByUserNameRatingAndReviewSiteCall(username, howManyReviews, minimumRatings, reviewsSite, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get X last reviews that equal or over X stars of a review site of an account
     * Get X last reviews that equal or over X stars of a review site (For example, Google reviewsâ€¦)
     * @param username User Name or Email address (required)
     * @param howManyReviews How many reviews (required)
     * @param minimumRatings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param reviewsSite Review site name (required)
     * @return List&lt;Review&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Review> getReviewsByUserNameRatingAndReviewSite(String username, String howManyReviews, String minimumRatings, String reviewsSite) throws ApiException {
        ApiResponse<List<Review>> resp = getReviewsByUserNameRatingAndReviewSiteWithHttpInfo(username, howManyReviews, minimumRatings, reviewsSite);
        return resp.getData();
    }

    /**
     * Get X last reviews that equal or over X stars of a review site of an account
     * Get X last reviews that equal or over X stars of a review site (For example, Google reviewsâ€¦)
     * @param username User Name or Email address (required)
     * @param howManyReviews How many reviews (required)
     * @param minimumRatings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param reviewsSite Review site name (required)
     * @return ApiResponse&lt;List&lt;Review&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Review>> getReviewsByUserNameRatingAndReviewSiteWithHttpInfo(String username, String howManyReviews, String minimumRatings, String reviewsSite) throws ApiException {
        com.squareup.okhttp.Call call = getReviewsByUserNameRatingAndReviewSiteValidateBeforeCall(username, howManyReviews, minimumRatings, reviewsSite, null, null);
        Type localVarReturnType = new TypeToken<List<Review>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get X last reviews that equal or over X stars of a review site of an account (asynchronously)
     * Get X last reviews that equal or over X stars of a review site (For example, Google reviewsâ€¦)
     * @param username User Name or Email address (required)
     * @param howManyReviews How many reviews (required)
     * @param minimumRatings Minimum review rating (reviews that are equal or over minimumRatings stars) (required)
     * @param reviewsSite Review site name (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getReviewsByUserNameRatingAndReviewSiteAsync(String username, String howManyReviews, String minimumRatings, String reviewsSite, final ApiCallback<List<Review>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getReviewsByUserNameRatingAndReviewSiteValidateBeforeCall(username, howManyReviews, minimumRatings, reviewsSite, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Review>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for postCommentOnReview
     * @param reviewid Review ID (required)
     * @param commenttext Comment Text  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call postCommentOnReviewCall(String reviewid, String commenttext, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/postCommentOnReview";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (reviewid != null)
        localVarFormParams.put("reviewid", reviewid);
        if (commenttext != null)
        localVarFormParams.put("commenttext", commenttext);

        final String[] localVarAccepts = {
            "application/json", "application/xml"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/x-www-form-urlencoded"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call postCommentOnReviewValidateBeforeCall(String reviewid, String commenttext, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'reviewid' is set
        if (reviewid == null) {
            throw new ApiException("Missing the required parameter 'reviewid' when calling postCommentOnReview(Async)");
        }
        
        // verify the required parameter 'commenttext' is set
        if (commenttext == null) {
            throw new ApiException("Missing the required parameter 'commenttext' when calling postCommentOnReview(Async)");
        }
        

        com.squareup.okhttp.Call call = postCommentOnReviewCall(reviewid, commenttext, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Comment on a Feedback / Review
     * This API call posts a Comment on a Feedback / Review. When posted, the Platform sends an Email to the Commenter / Reviewer with a copy of the posted Comment. NOTE: The Moderation Team receives a copy of the Email sent to the Commenter / Reviewer  The API call has the same effect as using the Reputation Control Center (URL: https://reputationcrm.com/reputation-control), locating in the datatable the Feedback / Review that will be commented, and clicking on the &#39;Comment on the Platform&#39; button to leave a Comment  Please refer https://reputationcrm.com/api/repcrm-api-img/CommentOnReview.jpg for more information 
     * @param reviewid Review ID (required)
     * @param commenttext Comment Text  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void postCommentOnReview(String reviewid, String commenttext) throws ApiException {
        postCommentOnReviewWithHttpInfo(reviewid, commenttext);
    }

    /**
     * Comment on a Feedback / Review
     * This API call posts a Comment on a Feedback / Review. When posted, the Platform sends an Email to the Commenter / Reviewer with a copy of the posted Comment. NOTE: The Moderation Team receives a copy of the Email sent to the Commenter / Reviewer  The API call has the same effect as using the Reputation Control Center (URL: https://reputationcrm.com/reputation-control), locating in the datatable the Feedback / Review that will be commented, and clicking on the &#39;Comment on the Platform&#39; button to leave a Comment  Please refer https://reputationcrm.com/api/repcrm-api-img/CommentOnReview.jpg for more information 
     * @param reviewid Review ID (required)
     * @param commenttext Comment Text  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> postCommentOnReviewWithHttpInfo(String reviewid, String commenttext) throws ApiException {
        com.squareup.okhttp.Call call = postCommentOnReviewValidateBeforeCall(reviewid, commenttext, null, null);
        return apiClient.execute(call);
    }

    /**
     * Comment on a Feedback / Review (asynchronously)
     * This API call posts a Comment on a Feedback / Review. When posted, the Platform sends an Email to the Commenter / Reviewer with a copy of the posted Comment. NOTE: The Moderation Team receives a copy of the Email sent to the Commenter / Reviewer  The API call has the same effect as using the Reputation Control Center (URL: https://reputationcrm.com/reputation-control), locating in the datatable the Feedback / Review that will be commented, and clicking on the &#39;Comment on the Platform&#39; button to leave a Comment  Please refer https://reputationcrm.com/api/repcrm-api-img/CommentOnReview.jpg for more information 
     * @param reviewid Review ID (required)
     * @param commenttext Comment Text  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call postCommentOnReviewAsync(String reviewid, String commenttext, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = postCommentOnReviewValidateBeforeCall(reviewid, commenttext, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
}
